/*
class demo on Jan 15, 2015
 By Mohit Hingorani
 please email me at mohit@mat.ucsb.edu
 */

int radius = 100;
int xPosition  = 20;


float [][] dataMatrix = null;
float maxValue ;
int numRows, numColumns;
int rectWidth = 14;
int rectHeight = 18;

int drawSpaceWidth, drawSpaceHeight;
int horizontalMargin, verticalMargin;

PFont headerFont = createFont( "Arial", 20, true);
PFont legendFont = createFont( "Calibri", 14, true);
Table myTable;

void setup() {
  
  size( 1870, 950);
  background(0);
  smooth();
  frameRate( 10 );     

  myTable = loadTable( "matrix.csv" );           
  numRows = myTable.getRowCount();
  numColumns = myTable.getColumnCount();

  dataMatrix = new float[numRows][numColumns];

  for ( int i = 0; i< numRows; i++) {
    for ( int j = 0; j< numColumns; j++) {
      dataMatrix[ i ][ j ] = myTable.getFloat( i, j );                
      print( dataMatrix[ i ][ j ] + " ");
    }
    println();
  }

  maxValue = dataMatrix[0][0];

  for ( int i = 0; i< numRows; i++) {
    for ( int j = 0; j< numColumns; j++) {
      maxValue = max( dataMatrix[ i ][ j ], maxValue );
    }
  }
  
  drawSpaceWidth = rectWidth * numRows;
  drawSpaceHeight = rectHeight * numColumns;

  horizontalMargin = ( width - drawSpaceWidth ) / 2;
  verticalMargin = ( height - drawSpaceHeight ) / 2; 
  
  noLoop();
  println( numRows + "  "+ numColumns + " " + maxValue );
  println( " setup done");
}

void draw() {
  
  background(0);
  
  colorMode(RGB);
  fill( 200 );
  textAlign( LEFT );
  textFont( headerFont );  
  text( "Controversy of Books for Each Subject Over Popularity", 15, 25 );
  
  textFont( headerFont );
  textAlign(CENTER, CENTER );
  text( "Popularity", horizontalMargin / 2, verticalMargin + drawSpaceHeight / 2 );
  text( "Subject", horizontalMargin + drawSpaceWidth / 2, verticalMargin + drawSpaceHeight  + verticalMargin / 2 );
  
  textFont( legendFont );
  textAlign( RIGHT, CENTER );
  for ( int i = 0; i < numColumns; i++ ) {
    if ( i == 0 )
      text( "<10", horizontalMargin - 10, verticalMargin + rectHeight / 2 + i * rectHeight );
    else if ( i == numColumns - 1 )
      text( "400+", horizontalMargin - 10, verticalMargin + rectHeight / 2 + i * rectHeight );
    else
      text( "" + i * 10 + "-" + ( i + 1 ) * 10, horizontalMargin - 10, verticalMargin + rectHeight / 2 + i * rectHeight );
  }
  
  textAlign( LEFT, CENTER );
  rotate( PI / 2 );
  for ( int i = 0; i < numRows; i++ ) {
    text( "" + i * 10, verticalMargin + drawSpaceHeight + 5, -1 * ( horizontalMargin + rectHeight / 2 + i * rectWidth ) );
  }
  rotate( - PI / 2 );
  
  textFont( legendFont );
  textAlign( LEFT, CENTER );
  text( "less controversial", drawSpaceWidth + horizontalMargin - 400, verticalMargin / 2 - 25 );
  textAlign( RIGHT, CENTER );
  text( "more controversial", drawSpaceWidth + horizontalMargin, verticalMargin / 2 - 25 );
  
  colorMode(RGB);
  noStroke();
  for ( int i = 0; i < 100; i += 1 ) {
    fill( 0, 55 + 200 * i / 100, 55 + 200 * i / 100 );
    rect( drawSpaceWidth + horizontalMargin - 400 + i * 4, verticalMargin / 2 - 15, 4, 30 ); 
  }
  
  translate( horizontalMargin, verticalMargin );
  for ( int  i = 0; i<  numRows; i++) {
    for ( int  j = 0; j < numColumns; j++) {      
      if ( dataMatrix[ i ][ j ] != -1 ) {
        noStroke();
        if ( dataMatrix[ i ][ j ] > 0.27 )
          stroke( 255 );
          
        fill( 0, 55 + 200 * dataMatrix[ i ][ j ] / maxValue, 55 + 200 * dataMatrix[ i ][ j ] / maxValue );                      
        rect( i * rectWidth, j * rectHeight, rectWidth, rectHeight );
      }
    }
  }
  
}


